import { RequestHandlersList } from './glossary';
import { createStart } from './start/createStart';
import { createStop } from './stop/createStop';
export interface SetupWorkerApi {
    start: ReturnType<typeof createStart>;
    stop: ReturnType<typeof createStop>;
    /**
     * Prepends given request handlers to the list of existing handlers.
     */
    use: (...handlers: RequestHandlersList) => void;
    /**
     * Marks all request handlers that respond using `res.once()` as unused.
     */
    restoreHandlers: () => void;
    /**
     * Resets request handlers to the initial list given to the `setupWorker` call, or to the explicit next request handlers list, if given.
     */
    resetHandlers: (...nextHandlers: RequestHandlersList) => void;
}
export declare function setupWorker(...requestHandlers: RequestHandlersList): SetupWorkerApi;
